<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::RequiresShutdown Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">RequiresShutdown</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::RequiresShutdown Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_requires_shutdown_8h_source.html">RequiresShutdown.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::utils::RequiresShutdown:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1acl_1_1_a_v_s_connection_manager.html" title="alexaClientSDK::acl\l::AVSConnectionManager" alt="" coords="303,5,478,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1acl_1_1_message_router_interface.html" title="alexaClientSDK::acl\l::MessageRouterInterface" alt="" coords="303,68,478,107"/>
<area shape="rect" id="node6" href="classalexa_client_s_d_k_1_1acl_1_1_transport_interface.html" title="alexaClientSDK::acl\l::TransportInterface" alt="" coords="321,131,460,169"/>
<area shape="rect" id="node9" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html" title="alexaClientSDK::adsl\l::DirectiveRouter" alt="" coords="317,193,464,232"/>
<area shape="rect" id="node10" href="classalexa_client_s_d_k_1_1afml_1_1_audio_activity_tracker.html" title="alexaClientSDK::afml\l::AudioActivityTracker" alt="" coords="316,256,466,295"/>
<area shape="rect" id="node11" href="classalexa_client_s_d_k_1_1afml_1_1_visual_activity_tracker.html" title="alexaClientSDK::afml\l::VisualActivityTracker" alt="" coords="315,319,467,357"/>
<area shape="rect" id="node12" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_call_manager_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CallManagerInterface" alt="" coords="269,381,512,420"/>
<area shape="rect" id="node13" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::DirectiveSequencer\lInterface" alt="" coords="275,444,507,496"/>
<area shape="rect" id="node15" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1external_media_player_1_1_external_media_adapter_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::externalMedia\lPlayer::ExternalMediaAdapterInterface" alt="" coords="265,520,516,572"/>
<area shape="rect" id="node16" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1test_1_1_mock_media_player.html" title="A mock MediaPlayer for unit tests. " alt="" coords="292,596,489,648"/>
<area shape="rect" id="node17" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_object.html" title="Test class which implements RequiresShutdown. " alt="" coords="292,672,489,711"/>
<area shape="rect" id="node18" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html" title="alexaClientSDK::bluetooth\lImplementations::blueZ\l::BlueZDeviceManager" alt="" coords="302,735,479,787"/>
<area shape="rect" id="node19" href="classalexa_client_s_d_k_1_1capabilities_delegate_1_1_capabilities_delegate.html" title="alexaClientSDK::capabilities\lDelegate::CapabilitiesDelegate" alt="" coords="288,811,493,849"/>
<area shape="rect" id="node20" href="classalexa_client_s_d_k_1_1capability_agents_1_1aip_1_1_audio_input_processor.html" title="alexaClientSDK::capability\lAgents::aip::AudioInputProcessor" alt="" coords="281,873,500,912"/>
<area shape="rect" id="node21" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alerts_capability_agent.html" title="alexaClientSDK::capability\lAgents::alerts::AlertsCapabilityAgent" alt="" coords="272,936,510,975"/>
<area shape="rect" id="node22" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html" title="alexaClientSDK::capability\lAgents::audioPlayer::AudioPlayer" alt="" coords="281,999,501,1037"/>
<area shape="rect" id="node23" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth.html" title="alexaClientSDK::capability\lAgents::bluetooth::Bluetooth" alt="" coords="296,1061,485,1100"/>
<area shape="rect" id="node24" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_do_not_disturb_capability_agent.html" title="alexaClientSDK::capability\lAgents::doNotDisturb::DoNotDisturb\lCapabilityAgent" alt="" coords="273,1124,508,1176"/>
<area shape="rect" id="node25" href="classalexa_client_s_d_k_1_1capability_agents_1_1equalizer_1_1_equalizer_capability_agent.html" title="alexaClientSDK::capability\lAgents::equalizer::EqualizerCapabilityAgent" alt="" coords="250,1200,531,1239"/>
<area shape="rect" id="node26" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html" title="alexaClientSDK::capability\lAgents::externalMediaPlayer\l::ExternalMediaPlayer" alt="" coords="295,1263,487,1315"/>
<area shape="rect" id="node27" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_capability_agent.html" title="alexaClientSDK::capability\lAgents::mrm::MRMCapabilityAgent" alt="" coords="276,1339,505,1377"/>
<area shape="rect" id="node28" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_handler_interface.html" title="alexaClientSDK::capability\lAgents::mrm::MRMHandlerInterface" alt="" coords="273,1401,508,1440"/>
<area shape="rect" id="node29" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html" title="alexaClientSDK::capability\lAgents::notifications::\lNotificationRenderer" alt="" coords="302,1464,480,1516"/>
<area shape="rect" id="node30" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notifications_capability_agent.html" title="alexaClientSDK::capability\lAgents::notifications::\lNotificationsCapabilityAgent" alt="" coords="297,1540,484,1592"/>
<area shape="rect" id="node31" href="classalexa_client_s_d_k_1_1capability_agents_1_1playback_controller_1_1_playback_controller.html" title="alexaClientSDK::capability\lAgents::playbackController\l::PlaybackController" alt="" coords="300,1616,481,1668"/>
<area shape="rect" id="node32" href="classalexa_client_s_d_k_1_1capability_agents_1_1playback_controller_1_1_playback_router.html" title="alexaClientSDK::capability\lAgents::playbackController\l::PlaybackRouter" alt="" coords="300,1692,481,1744"/>
<area shape="rect" id="node33" href="classalexa_client_s_d_k_1_1capability_agents_1_1speaker_manager_1_1_speaker_manager.html" title="alexaClientSDK::capability\lAgents::speakerManager\l::SpeakerManager" alt="" coords="302,1768,480,1820"/>
<area shape="rect" id="node34" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html" title="alexaClientSDK::capability\lAgents::speechSynthesizer\l::SpeechSynthesizer" alt="" coords="299,1844,482,1896"/>
<area shape="rect" id="node35" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_sender.html" title="alexaClientSDK::capability\lAgents::system::SoftwareInfoSender" alt="" coords="272,1920,510,1959"/>
<area shape="rect" id="node36" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_send_request.html" title="alexaClientSDK::capability\lAgents::system::SoftwareInfoSend\lRequest" alt="" coords="278,1983,504,2035"/>
<area shape="rect" id="node37" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_user_inactivity_monitor.html" title="This class implements a CapabilityAgent that handles the SetEndpoint directive. " alt="" coords="291,2059,491,2111"/>
<area shape="rect" id="node38" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html" title="alexaClientSDK::capability\lAgents::templateRuntime\l::TemplateRuntime" alt="" coords="302,2135,480,2187"/>
<area shape="rect" id="node39" href="classalexa_client_s_d_k_1_1certified_sender_1_1_certified_sender.html" title="alexaClientSDK::certified\lSender::CertifiedSender" alt="" coords="306,2211,475,2249"/>
<area shape="rect" id="node40" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_a_v_s_communication.html" title="alexaClientSDK::integration\l::test::AVSCommunication" alt="" coords="298,2273,483,2312"/>
<area shape="rect" id="node41" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_message_sender.html" title="alexaClientSDK::integration\l::test::TestMessageSender" alt="" coords="298,2336,483,2375"/>
<area shape="rect" id="node42" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1test_state_provider.html" title="alexaClientSDK::integration\l::test::testStateProvider" alt="" coords="298,2399,483,2437"/>
<area shape="rect" id="node43" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_player.html" title="alexaClientSDK::mediaPlayer\l::android::AndroidSLESMediaPlayer" alt="" coords="273,2461,508,2500"/>
<area shape="rect" id="node44" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html" title="alexaClientSDK::mediaPlayer\l::MediaPlayer" alt="" coords="293,2524,489,2563"/>
<area shape="rect" id="node45" href="classalexa_client_s_d_k_1_1media_player_1_1_source_interface.html" title="alexaClientSDK::mediaPlayer\l::SourceInterface" alt="" coords="293,2587,489,2625"/>
<area shape="rect" id="node46" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_content_decrypter.html" title="alexaClientSDK::playlist\lParser::ContentDecrypter" alt="" coords="304,2649,477,2688"/>
<area shape="rect" id="node47" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_playlist_parser.html" title="alexaClientSDK::playlist\lParser::PlaylistParser" alt="" coords="309,2712,472,2751"/>
<area shape="rect" id="node48" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_url_content_to_attachment_converter.html" title="Class that handles the streaming of urls containing media into Attachments. " alt="" coords="284,2775,497,2827"/>
<area shape="rect" id="node49" href="classalexa_client_s_d_k_1_1sample_app_1_1_interaction_manager.html" title="alexaClientSDK::sampleApp\l::InteractionManager" alt="" coords="296,2851,485,2889"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1acl_1_1_message_router.html" title="alexaClientSDK::acl\l::MessageRouter" alt="" coords="613,5,752,44"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1acl_1_1test_1_1_mock_message_router.html" title="alexaClientSDK::acl\l::test::MockMessageRouter" alt="" coords="590,68,774,107"/>
<area shape="rect" id="node7" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_transport.html" title="alexaClientSDK::acl\l::HTTP2Transport" alt="" coords="613,131,752,169"/>
<area shape="rect" id="node8" href="classalexa_client_s_d_k_1_1acl_1_1transport_1_1test_1_1_mock_transport.html" title="alexaClientSDK::acl\l::transport::test::MockTransport" alt="" coords="579,193,785,232"/>
<area shape="rect" id="node14" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html" title="alexaClientSDK::adsl\l::DirectiveSequencer" alt="" coords="609,451,755,489"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aae7174ed932ae1413460255238c4422b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#aae7174ed932ae1413460255238c4422b">RequiresShutdown</a> (const std::string &amp;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>)</td></tr>
<tr class="separator:aae7174ed932ae1413460255238c4422b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a649b80d77e4e6f66e218ee3bfc71823b"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">~RequiresShutdown</a> ()</td></tr>
<tr class="memdesc:a649b80d77e4e6f66e218ee3bfc71823b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a649b80d77e4e6f66e218ee3bfc71823b">More...</a><br /></td></tr>
<tr class="separator:a649b80d77e4e6f66e218ee3bfc71823b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a745cd4dc404db52f7d0afbf838454fac"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> () const</td></tr>
<tr class="separator:a745cd4dc404db52f7d0afbf838454fac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350a147e52eb3ad3c1326e6639861066"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a> ()</td></tr>
<tr class="separator:a350a147e52eb3ad3c1326e6639861066"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9352626109735aba40b5fb310913355"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#af9352626109735aba40b5fb310913355">isShutdown</a> () const</td></tr>
<tr class="separator:af9352626109735aba40b5fb310913355"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a66df7916e28559f30233c2ff5a166293"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a66df7916e28559f30233c2ff5a166293">doShutdown</a> ()=0</td></tr>
<tr class="separator:a66df7916e28559f30233c2ff5a166293"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Abstract base class which requires the derived class to implement a shutdown function and tries to verify that client code calls <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a></code> correctly. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aae7174ed932ae1413460255238c4422b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae7174ed932ae1413460255238c4422b">&#9670;&nbsp;</a></span>RequiresShutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::RequiresShutdown::RequiresShutdown </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the class or object which requires shutdown calls. Used in log messages when problems are detected in shutdown or destruction sequences. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a649b80d77e4e6f66e218ee3bfc71823b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a649b80d77e4e6f66e218ee3bfc71823b">&#9670;&nbsp;</a></span>~RequiresShutdown()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::RequiresShutdown::~RequiresShutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a66df7916e28559f30233c2ff5a166293"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a66df7916e28559f30233c2ff5a166293">&#9670;&nbsp;</a></span>doShutdown()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::utils::RequiresShutdown::doShutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p></p>
<p class="">Prepares/enables this object to be deleted. This should be the last function called on this object prior to deleting (or resetting) its shared_ptr.</p>
<dl class="section warning"><dt>Warning</dt><dd><ul>
<li>Attempting to call functions on this object after calling <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> can result in undefined behavior. </li>
<li>Neglecting to call <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> on this object can result in resource leaks or other undefined behavior. </li>
</ul>
</dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1test_state_provider.html#a2a8bab03596f1ae5e30699a65cffb605">alexaClientSDK::integration::test::testStateProvider</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth.html#a6c0eccf08750a8629032205001dffced">alexaClientSDK::capabilityAgents::bluetooth::Bluetooth</a>, <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_h_t_t_p2_transport.html#a34de549deef0a6e904a60809fbeb08f2">alexaClientSDK::acl::HTTP2Transport</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1_media_player.html#a98c1f81565f95a53704af13a3482e55f">alexaClientSDK::mediaPlayer::MediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_a_v_s_communication.html#a540f6df643b2c59105edb764cb6debcd">alexaClientSDK::integration::test::AVSCommunication</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_message_sender.html#a03da143f79dd06ae6be8125f2f97d467">alexaClientSDK::integration::test::TestMessageSender</a>, <a class="el" href="classalexa_client_s_d_k_1_1media_player_1_1android_1_1_android_s_l_e_s_media_player.html#a821fe823e9cf4b7570a0bc27beae5b58">alexaClientSDK::mediaPlayer::android::AndroidSLESMediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1test_1_1_mock_media_player.html#a9bfd9a52a1bd721c6d5c2614775a264a">alexaClientSDK::avsCommon::utils::mediaPlayer::test::MockMediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_capability_agent.html#aea7b2697e196f19fab037628a943c840">alexaClientSDK::capabilityAgents::mrm::MRMCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_url_content_to_attachment_converter.html#a527778de223ebd5018d25a263e28f899">alexaClientSDK::playlistParser::UrlContentToAttachmentConverter</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_do_not_disturb_capability_agent.html#ae9feacfd215545e3ca2bf76c83800710">alexaClientSDK::capabilityAgents::doNotDisturb::DoNotDisturbCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1equalizer_1_1_equalizer_capability_agent.html#afe0cfa54534e60ee2a1bfb821f5cab0e">alexaClientSDK::capabilityAgents::equalizer::EqualizerCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capabilities_delegate_1_1_capabilities_delegate.html#a332cfa13fb6b447645650fe855ea60a6">alexaClientSDK::capabilitiesDelegate::CapabilitiesDelegate</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_sender.html#a03f59237a5112d5e2eb6b221362fc351">alexaClientSDK::capabilityAgents::system::SoftwareInfoSender</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1speaker_manager_1_1_speaker_manager.html#af5bea5c3dbdba3891157fce9b8e86529">alexaClientSDK::capabilityAgents::speakerManager::SpeakerManager</a>, <a class="el" href="classalexa_client_s_d_k_1_1acl_1_1_message_router.html#a6e612d03dfabab3bfeae7e681e8479f2">alexaClientSDK::acl::MessageRouter</a>, <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_content_decrypter.html#a44fedb381e9aa5afbf5020c0dc97b3c6">alexaClientSDK::playlistParser::ContentDecrypter</a>, <a class="el" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a481c68aded0e2cd397b7061d3184d916">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8cfe9c19a236cefed6242f7dbf7442ec">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_send_request.html#aa787bbd434d306cfd24173a948c3efae">alexaClientSDK::capabilityAgents::system::SoftwareInfoSendRequest</a>, <a class="el" href="classalexa_client_s_d_k_1_1playlist_parser_1_1_playlist_parser.html#a06bd0ac6b1df07d015134f1a0e65c30f">alexaClientSDK::playlistParser::PlaylistParser</a>, and <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_object.html#af1bed0b34eff3e0d1ffa69b2ab0c6127">alexaClientSDK::avsCommon::utils::test::Object</a>.</p>

</div>
</div>
<a id="af9352626109735aba40b5fb310913355"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af9352626109735aba40b5fb310913355">&#9670;&nbsp;</a></span>isShutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::RequiresShutdown::isShutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Checks whether this object has had <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a></code> called on it.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if this object has been shut down, else <code>false</code>. </dd></dl>

</div>
</div>
<a id="a745cd4dc404db52f7d0afbf838454fac"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a745cd4dc404db52f7d0afbf838454fac">&#9670;&nbsp;</a></span>name()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string &amp; alexaClientSDK::avsCommon::utils::RequiresShutdown::name </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Returns the name of this object.</p>
<dl class="section return"><dt>Returns</dt><dd>The name of the object. </dd></dl>

</div>
</div>
<a id="a350a147e52eb3ad3c1326e6639861066"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a350a147e52eb3ad3c1326e6639861066">&#9670;&nbsp;</a></span>shutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::RequiresShutdown::shutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Prepares/enables this object to be deleted. This should be the last function called on this object prior to deleting (or resetting) its shared_ptr.</p>
<dl class="section warning"><dt>Warning</dt><dd><ul>
<li>Attempting to call functions on this object after calling <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> can result in undefined behavior. </li>
<li>Neglecting to call <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown()</a> on this object can result in resource leaks or other undefined behavior. </li>
</ul>
</dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/include/AVSCommon/Utils/<a class="el" href="_requires_shutdown_8h_source.html">RequiresShutdown.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/src/<a class="el" href="_requires_shutdown_8cpp.html">RequiresShutdown.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
